package ch.programmieraufgaben.planetensortieren.controller;

/**
 * Ergänze um eigene @Sort-Funktionen.
 * @author Philipp Gressly (phi AT gressly DOT ch)
 */
public class Sortierer extends SortierBasis{
   /**
    * randomSort: John Bysäth / Philipp Gressly (1988)
    * Vertausche zwei beliebige Elemente und teste, ob die Menge
    * nun sortiert ist. Wenn nicht: starte von vorn.
    * Dies ist wohl mit Abstand der schlechteste Sortieralgorithmus, der aber nach dem
    * Gesetz der großen Zahlen den Array früher oder später sortieren wird.
    * (Gemein ist der von John eingführte erste Vertauschungsschritt, der ein
    *  bereits sortiertes Feld garantiert wieder "zerstört".)
    */
    @Sort
    public void randomSortTest() {
       rSortTausche();
       while(! istSortiert()) {
          rSortTausche();   }
    }
   
    // Hilfsmethode für "randomSortTest"
    private void rSortTausche() {
      int pos1 = (int) (Math.random() * (getLastSortPos() - getFirstSortPos() + 1)) + getFirstSortPos();  
      int pos2 = (int) (Math.random() * (getLastSortPos() - getFirstSortPos() + 1)) + getFirstSortPos();
      this.tausche(pos1, pos2);
    }
    
///////////////////////////////////////////////////////////////////////////////////////////////////////////////
   
     
     /* Entwickle hier deine eigene Sort-Methoden.
      * 1. Der "public"-Methode muss jeweils die Annotation @Sort vorangestellt werden, damit
      *    die Metohde im GUI ausgewählt werden kann. M. a. W. damit das Programm weiß, dass es
      *    sich dabei um eine sortier-Methode handelt, die aufgerufen werden darf.
      *    
      * 2. Verwende die folgenden Methoden:
      *    a) getFirstSortPos()      : Erste Array Position (normalerweise 0)
      *    b) getLastSortPos()       : Letzte Array position (Bei 8 Planeten -> 7)
      *    c) tausche(pos1, pos2)    : Tausche die Planeten an Pos1 mit Pos2
      *    d) istKleiner(pos1, pos2) : gibt true (WAHR) zurück, genau dann, wenn der Planet
      *                                an position "pos1" kleiner ist als derjenige an "pos2".
      *                                ACHTUNG: bei Gleichheit gibt die Methode "false" aus!
      *                                "kleiner" bezieht sich auf das vom Anwender gewählte Kriterium
      *                                z. B. "Name", "Abstand zur Sonne", ...  
      *    e) istSortiert()          : ein tiviales Vorgehen, um zu testen, ob die Daten sortiert sind.
      *                                Von links nach rechts wird paarweise verglichen.
      *                                Verwende diesen Algorithmus sparsam, denn in der Regel gibt es
      *                                raschere Algorithmen.
      */
    @Sort
     public void mySorierer() {
         // Your code goes here
         System.out.println("starting My Sort");
     } 
    
//////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
} // end of class Sortierer
