package ch.programmieraufgaben.planetensortieren.gui;

import java.awt.BorderLayout;

import javax.swing.JPanel;

import ch.programmieraufgaben.planetensortieren.model.Sonnensystem;


/**
 * Main Panel contining the Planets (SonnensystemPanel and the ControllPanel.
 * @author Philipp Gressly (phi AT gressly DOT ch)
 */
public class MainPanel extends JPanel implements GUI{

   ControllPanel controllPanel = new ControllPanel(this);
   SonnensystemPanel sonnensystemPanel;
   
   public MainPanel() {
       setLayout(new BorderLayout());
       add(controllPanel, BorderLayout.SOUTH);
       Sonnensystem sonnensystem = new Sonnensystem(this);
       sonnensystemPanel = new SonnensystemPanel(sonnensystem, this);
       add(sonnensystemPanel, BorderLayout.CENTER); }


  /*
   * @see eu.gressly.hw.planeten.gui.GUI#getKriterium()
   */
  @Override
  public String getKriterium() {
    return controllPanel.getKriterium();  }

  
  /*
   * @see eu.gressly.hw.planeten.gui.GUI#setKriterium(java.lang.String)
   */
  @Override
  public void setKriterium(String kriterium) {
    sonnensystemPanel.setKriterium(kriterium);  }
  
  
  /*
   * @see eu.gressly.hw.planeten.gui.GUI#tausche(int, int)
   */
  @Override
  public void tausche(int pos1, int pos2) {
    sonnensystemPanel.tausche(pos1, pos2); }

  /*
   * @see eu.gressly.hw.planeten.gui.GUI#vergleich(int, int, boolean)
   */
  @Override
  public void vergleich(int pos1, int pos2, boolean istKleiner) {
    sonnensystemPanel.vergleich(pos1, pos2, istKleiner);  }

  /*
   * @see eu.gressly.hw.planeten.gui.GUI#getSonnensystem()
   */
  @Override
  public Sonnensystem getSonnensystem() {
    return sonnensystemPanel.sonnensystem; }

  
  /*
   * @see eu.gressly.hw.planeten.gui.GUI#getVitesse()
   */
  @Override
  public long getVitesse() {
    return controllPanel.getVitesse(); }

  
  /*
   * @see eu.gressly.hw.planeten.gui.GUI#stoppRunningThread()
   */
  @Override
  public void stopSorting() {
    controllPanel.stoppRunningThread();  }

  
  /*
   * @see eu.gressly.hw.planeten.gui.GUI#isAscendig()
   */
  @Override
  public boolean isAscendig() {
    return controllPanel.isAscending(); }

  /*
   * @see eu.gressly.hw.planeten.gui.GUI#validateSonnensystemPanel()
   */
  @Override
  public void validateSonnensystemPanel() {
    sonnensystemPanel.layoutPlaneten(); }


}  // end of class MainPanel
